diff --git a/envy24control/README b/envy24control/README
index 40c4fe6..ea4ba11 100644
--- a/envy24control/README
+++ b/envy24control/README
@@ -5,7 +5,11 @@ Needs:
 
 To build (from unpacked tarball):
 	./configure
-If you use GTK+-1.2, pass --with-gtk2=no
+
+(Note: Envy24control versions > 1.0 (aka "mudita24") expect recent versions
+ of Gtk2 as the GtkScale markers used on the mixer/ADC/DAC sliders have
+ existed only since Gtk version 2.16.  Do not use version 0.6.0's configure
+ option "-with-gtk2=no" and the accompanying file configure.in-gtk1.)
 
 	make
 	su -c 'make install'
@@ -14,3 +18,77 @@ To build (from GIT):
 	./gitcompile
 	su -c 'make install'
 
+--------------------
+
+Notes on the Envy24's hardware Digital Mixer and hardware Metering,
+by Niels Mayer ( http://nielsmayer.com ):
+--------------------
+
+The "Monitor Inputs" and "Monitor PCMs" tabs contain multiple scale widgets
+grouped into L/R pairs and an associated peak-level meter. Each scale
+widget represents the 24 bit attenuation value of each input to the
+ice1712-based soundcard's digital mixer. This mixer is typically used for
+zero-latency monitoring of "live" inputs, alongside backing sounds and
+effects coming from the eight channels of PCM feeding the digital mixer.
+When many inputs are "hot" simultaneously these scale-widgets attenuate the
+inputs going into the digital mixer to prevent the output from clipping.
+For details see http://nielsmayer.com/npm/envy24mixer-architecture.png
+
+(from http://alsa.cybermirror.org/manuals/icensemble/envy24.pdf )
+
+This is what the above manual says about the Envy24's digital mixer:
+> 4.5.5 Multi-Track Digital Monitoring
+> 
+> The Envy24 integrates a 36-bit resolution digital hardware mixer. The
+> width of the data path is strictly to ensure that during processing of
+> all the channels, under any condition, no resolution is lost. The
+> dynamic range of the end user system will be limited by the range of the
+> physical output devices used. In order to maintain identical gain to the
+> input stream (i.e. 0dB), the resulting 24-bit is not msb-aligned to the
+> 36-bit. The overflow bits correspond to the analog distortion due to
+> saturation. The user would need to reduce the overall attenuation of the
+> inputs to avoid clipping. Insertion of the digital mixer adds only a
+> single sample cycle delay with respect to the original data. This
+> extremely low latency all digital mixer provides monitoring
+> functionality and can replace a traditional external analog input
+> mixer. There are 20 independent audio data streams to mix and control
+> the volume.
+
+
+Adjustment of responsivity vs. "zipper noise" from the 1.5dB steps at the
+top-range of the digital mixer attenuators is achieved by the following
+control under "Hardware Settings":
+
+> MT3B: Volume Control Rate Register
+> ...
+> Volume update rate control (sampling rate, PSYNC)
+> This register allows gradual change of the digital mixer volume
+> setting. The value in MT3B specifies the number of samples to elapse (in
+> hex) between each 1.5dB increment/decrement in volume mixer.  This gradual
+> volume update continues until the setting programmed into MT38 is
+> reached. The appropriate value to program may vary, but 00 or 01h are good
+> choices for most cases.
+
+The peak metering data is displayed as 0 to -48dBFS in envy24control's
+meters. This data is derived from the envy24's hardware peak metering:
+
+> MT3F: Peak Meter Data Register
+> [...]
+> Peak data derived from the absolute value of 9 msb.  00h min - FFh max
+> volume. Reading the register resets the meter to 00h.
+
+This resolution of the hardware metering is descibed by Fons Adriaensen in
+a mailing list discussion:
+
+http://lists.linuxaudio.org/pipermail/linux-audio-dev/2010-August/029009.html
+> [...] You have 128 steps between 0 and -6dB...
+> And even at -24dB the next step is 1.3dB lower. Below that
+> it gets worse radipdly. For a meter that is just supposed
+> to keep a check on peak levels it's OK.
+
+Note that hardware metering data is also available from the command-line:
+
+> amixer -c M66 cget iface=PCM,name='Multi Track Peak',numid=45
+> numid=45,iface=PCM,name='Multi Track Peak'
+>   ; type=INTEGER,access=r-------,values=22,min=0,max=255,step=0
+>   : values=63,62,51,49,56,60,63,62,59,54,0,0,0,0,0,0,0,0,0,0,113,112
diff --git a/envy24control/config.c b/envy24control/config.c
index 6933eef..828d8bc 100644
--- a/envy24control/config.c
+++ b/envy24control/config.c
@@ -46,7 +46,7 @@ void config_close()
 
 void config_set_stereo(GtkWidget *but, gpointer data)
 {
-  gint i=(gint)data;
+  gint i=(gint)((long)data); /* NPM: "(gint)((long)data)" suppress "config.c:49: warning: cast from pointer to integer of different size" */
   config_stereo[i]=GTK_TOGGLE_BUTTON(but)->active;
 }
 
diff --git a/envy24control/configure.in b/envy24control/configure.in
index 30dc8a8..85648cd 100644
--- a/envy24control/configure.in
+++ b/envy24control/configure.in
@@ -1,26 +1,14 @@
 AC_INIT(envy24control.c)
-AM_INIT_AUTOMAKE(envy24control, 0.6.0)
+AM_INIT_AUTOMAKE(mudita24, 1.0.3)
 AC_PROG_CC
 AC_PROG_INSTALL
 AC_HEADER_STDC
 
-AC_ARG_WITH(gtk2,
-  [  --with-gtk2=yes,no   Build with GTK+2 (default = yes)],
-  with_gtk2="$withval", with_gtk2="yes")
-
-if test "$with_gtk2" = "yes"; then
-
+## NPM: version > 1.0.1's logarithmic display requires log10() and therefore
+## "-lm". This solution suggested by Guido Scholz on Linux-Audio-Dev ML.
+AC_CHECK_LIB(m, log10,,AC_MSG_ERROR([required library missing]))
+## NPM: version > 1.0.0 requires gtk+2.0 due to use of functionality like
+## gtk_label_set_markup() and the Gtk Scale Markers being introduced in 2.16
 PKG_CHECK_MODULES(ENVY24CONTROL, gtk+-2.0 alsa >= 0.9.0)
 
-else
-
-AM_PATH_GTK(1.0.1)
-AM_PATH_ALSA(1.0.0)
-ENVY24CONTROL_CFLAGS="$CFLAGS $ALSA_CFLAGS $GTK_CFLAGS"
-ENVY24CONTROL_LIBS="$LIBS $ALSA_LIBS $GTK_LIBS"
-AC_SUBST(ENVY24CONTROL_CFLAGS)
-AC_SUBST(ENVY24CONTROL_LIBS)
-
-fi
-
 AC_OUTPUT(Makefile)
diff --git a/envy24control/configure.in-gtk2 b/envy24control/configure.in-gtk2
index d42aee8..7f13a73 100644
--- a/envy24control/configure.in-gtk2
+++ b/envy24control/configure.in-gtk2
@@ -1,5 +1,5 @@
 AC_INIT(envy24control.c)
-AM_INIT_AUTOMAKE(envy24control, 0.6.0)
+AM_INIT_AUTOMAKE(envy24control, 1.0.3)
 AC_PROG_CC
 AC_PROG_INSTALL
 AC_HEADER_STDC
diff --git a/envy24control/envy24control.h b/envy24control/envy24control.h
index f5c1e39..ec7b8f7 100644
--- a/envy24control/envy24control.h
+++ b/envy24control/envy24control.h
@@ -15,7 +15,7 @@
 #endif
 #define MAX_PROFILES 8
 #define MAX_PROFILE_NAME_LENGTH 20
-#define DEFAULT_PROFILERC "~/envy24control/profiles.conf"
+#define DEFAULT_PROFILERC "~/.envy24control/profiles.conf" /* NPM: use hidden directory for profiles */
 #define SYS_PROFILERC "/etc/envy24control/profiles.conf"
 #ifndef MKDIR
 #define MKDIR "/bin/mkdir"
@@ -58,6 +58,55 @@
 #define MAX_SPDIF_CHANNELS	2
 /* max number of PCM output channels */
 #define MAX_PCM_OUTPUT_CHANNELS	8
+/* NPM: the digital mixer max-attenuation in dB, per snd ice1712 architecture diagram
+   http://nielsmayer.com/npm/envy24mixer-architecture.png
+   taken from http://alsa.cybermirror.org/manuals/icensemble/envy24.pdf */
+/* NPM: the control values for the digital mixer are 0-96 and not the
+   dB attenuation values of MAX_MIXER_ATTENUATION_DB...
+   The following values comprise all the signals mixed in the ice1712's digital
+   mixer: MULTI_PLAYBACK_VOLUME, HW_MULTI_CAPTURE_VOLUME, IEC958_MULTI_CAPTURE_VOLUME:
+    > amixer -c M66 cget iface=MIXER,name='Multi Playback Volume'
+    numid=11,iface=MIXER,name='Multi Playback Volume'
+      ; type=INTEGER,access=rw---R--,values=2,min=0,max=96,step=0
+      : values=78,67
+      | dBscale-min=-144.00dB,step=1.50dB,mute=0
+    > amixer -c M66 cget iface=MIXER,name="H/W Multi Capture Volume"
+    numid=27,iface=MIXER,name='H/W Multi Capture Volume'
+      ; type=INTEGER,access=rw---R--,values=2,min=0,max=96,step=0
+      : values=0,0
+      | dBscale-min=-144.00dB,step=1.50dB,mute=0
+    > amixer -c M66 cget iface=MIXER,name="IEC958 Multi Capture Volume"
+    numid=31,iface=MIXER,name='IEC958 Multi Capture Volume'
+      ; type=INTEGER,access=rw------,values=2,min=0,max=96,step=0
+      : values=16,0
+*/
+#define MAX_MIXER_ATTENUATION_VALUE 96 /* for -144dB */
+#define LOW_MIXER_ATTENUATION_VALUE 33 /* for -49.5dB nb: 64-->-48dB where 96-64=32 */
+#define MIN_MIXER_ATTENUATION_VALUE 0  /* for 0dB */
+
+/*
+ * NPM: DAC and ADC constants
+ */
+#define MIN_ADC_GAIN -63
+#define MAX_ADC_GAIN 18
+#define MIN_DAC_GAIN -63
+#define MAX_DAC_GAIN 0
+#define ANALOG_GAIN_STEP_SIZE 12  /* this value gives a known -18dB step size for 24 bit attenuators, -6dB step for 16 bit attenuators */
+#define MIXER_ATTENUATOR_STEP_SIZE 8  /* this value gives a known -12dB step size for 24 bit attenuators, -6dB step for 16 bit attenuators */
+
+/*
+ * NPM: For peak meters
+ */
+#define MULTI_TRACK_PEAK_CHANNELS 22
+#define IDX_LMIX 20
+#define IDX_RMIX 21
+#define MAX_METERING_LEVEL 255 	/* level corresponding to 0dB output for ice1712 hardware peak meters */
+// #define MIN_METERING_LEVEL_DB -48.164799306 /* == 20*log10(1/(MAX_METERING_LEVEL+1)) */
+// #define MIN_METERING_LEVEL_DB −48.130803609 /* == 20*log10(1/MAX_METERING_LEVEL)     */
+
+/*
+ * NPM: 
+ */
 
 typedef struct {
 	unsigned int subvendor;	/* PCI[2c-2f] */
@@ -87,6 +136,11 @@ extern GtkWidget *mixer_clear_peaks_button;
 extern GtkWidget *mixer_drawing[20];
 extern GtkObject *mixer_adj[20][2];
 extern GtkWidget *mixer_vscale[20][2];
+extern GtkWidget *mixer_label[20][2]; /* NPM */
+extern GtkWidget *peak_label[MULTI_TRACK_PEAK_CHANNELS];     /* NPM */
+extern GtkWidget *adc_peak_label[MAX_INPUT_CHANNELS];	     /* NPM */
+extern GtkWidget *dac_peak_label[MAX_OUTPUT_CHANNELS];       /* NPM */
+
 extern GtkWidget *mixer_solo_toggle[20][2];
 extern GtkWidget *mixer_mute_toggle[20][2];
 extern GtkWidget *mixer_stereo_toggle[20];
@@ -111,6 +165,8 @@ extern GtkWidget *hw_rate_reset_check;
 extern GtkObject *hw_volume_change_adj;
 extern GtkWidget *hw_volume_change_spin;
 
+extern GtkWidget *hw_iec958_input_status_label; /* NPM */
+
 extern GtkWidget *hw_spdif_profi_nonaudio_radio;
 extern GtkWidget *hw_spdif_profi_audio_radio;
 
@@ -154,14 +210,17 @@ extern GtkWidget *input_interface_wavetable;
 extern GtkObject *av_dac_volume_adj[];
 extern GtkObject *av_adc_volume_adj[];
 extern GtkObject *av_ipga_volume_adj[];
-extern GtkLabel *av_dac_volume_label[];
-extern GtkLabel *av_adc_volume_label[];
-extern GtkLabel *av_ipga_volume_label[];
+extern GtkWidget *av_dac_volume_label[];
+extern GtkWidget *av_adc_volume_label[];
+extern GtkWidget *av_ipga_volume_label[];
 extern GtkWidget *av_dac_sense_radio[][4];
 extern GtkWidget *av_adc_sense_radio[][4];
 
 /* flags */
 extern int card_is_dmx6fire;
+extern int no_scale_marks;	/* NPM: --no_scale_marks option */
+extern GdkColor *meter_bg, *meter_fg; /* NPM: --bg_color --lights_color options */
+extern int card_has_delta_iec958_input_status; /* NPM added to support "Delta IEC958 Input Status" */
 
 gint level_meters_configure_event(GtkWidget *widget, GdkEventConfigure *event);
 gint level_meters_expose_event(GtkWidget *widget, GdkEventExpose *event);
@@ -189,6 +248,7 @@ gint master_clock_status_timeout_callback(gpointer data);
 gint internal_clock_status_timeout_callback(gpointer data);
 gint rate_locking_status_timeout_callback(gpointer data);
 gint rate_reset_status_timeout_callback(gpointer data);
+gint iec958_input_status_timeout_callback(gpointer data);
 void internal_clock_toggled(GtkWidget *togglebutton, gpointer data);
 void rate_locking_update(void);
 void rate_locking_toggled(GtkWidget *togglebutton, gpointer data);
@@ -209,6 +269,7 @@ void spdif_input_update(void);
 void spdif_input_toggled(GtkWidget *togglebutton, gpointer data);
 void analog_input_select_toggled(GtkWidget *togglebutton, gpointer data);
 void phono_input_toggled(GtkWidget *togglebutton, gpointer data);
+void iec958_input_status_update(void); /* NPM */
 
 void hardware_init(void);
 void hardware_postinit(void);
@@ -241,3 +302,8 @@ void adc_sense_toggled(GtkWidget *togglebutton, gpointer data);
 void control_input_callback(gpointer data, gint source, GdkInputCondition condition);
 void mixer_input_callback(gpointer data, gint source, GdkInputCondition condition);
 
+/* NPM: volume/db-related stuff added to volume.c */
+char* peak_level_to_db(int ival);
+void draw_24bit_attenuator_scale_markings(GtkScale *scale, GtkPositionType position, int draw_legend_p);
+void draw_dac_scale_markings(GtkScale *scale, GtkPositionType position);
+void draw_adc_scale_markings(GtkScale *scale, GtkPositionType position);
diff --git a/envy24control/hardware.c b/envy24control/hardware.c
index 73e3f0a..6d4f742 100644
--- a/envy24control/hardware.c
+++ b/envy24control/hardware.c
@@ -31,6 +31,7 @@ static snd_ctl_elem_value_t *analog_input_select;
 static snd_ctl_elem_value_t *breakbox_led;
 static snd_ctl_elem_value_t *spdif_on_off;
 static snd_ctl_elem_value_t *phono_input;
+static snd_ctl_elem_value_t *iec958_in_status; /* NPM: add feature to display "Delta IEC958 Input Status" */
 
 static inline int is_update_needed(void);
 
@@ -270,6 +271,31 @@ gint rate_reset_status_timeout_callback(gpointer data)
     return TRUE;
 }
 
+/* NPM: add feature to display "Delta IEC958 Input Status" */
+static int iec958_input_status_enabled = TRUE;
+gint iec958_input_status_timeout_callback(gpointer data)
+{
+  if (GTK_WIDGET_VISIBLE(hw_iec958_input_status_label) && iec958_input_status_enabled) {
+    int err;
+    if ((err = snd_ctl_elem_read(ctl, iec958_in_status)) < 0) {
+      char temp_text[1024];
+      sprintf(temp_text,
+	      "<span size=\"small\">Unable to read IEC958 Input Status:\n     %s</span>",
+	      snd_strerror(err));
+      gtk_label_set_markup(GTK_LABEL(hw_iec958_input_status_label),
+			   temp_text);
+      iec958_input_status_enabled = FALSE; /* NPM: to prevent constant retries on HW that doesn't support this feature, if it fails the first time it tries, assume it won't succeed later */
+    }
+    else if (snd_ctl_elem_value_get_boolean(iec958_in_status, 0))
+      gtk_label_set_markup(GTK_LABEL(hw_iec958_input_status_label),
+			   "<span size=\"medium\">Input Active</span>");
+    else
+      gtk_label_set_markup(GTK_LABEL(hw_iec958_input_status_label),
+			   "<span size=\"medium\">No Signal Detected</span>");
+  }
+  return TRUE;
+}
+
 void rate_locking_update(void)
 {
 	int err;
@@ -752,7 +778,8 @@ void hardware_init(void)
 	    snd_ctl_elem_value_malloc(&analog_input_select) < 0 ||
 	    snd_ctl_elem_value_malloc(&breakbox_led) < 0 ||
 	    snd_ctl_elem_value_malloc(&spdif_on_off) < 0 ||
-	    snd_ctl_elem_value_malloc(&phono_input) < 0) {
+	    snd_ctl_elem_value_malloc(&phono_input) < 0  ||
+	    snd_ctl_elem_value_malloc(&iec958_in_status) < 0) { /* NPM: add feature to display "Delta IEC958 Input Status" */
 		g_print("Cannot allocate memory\n");
 		exit(1);
 	}
@@ -798,6 +825,8 @@ void hardware_init(void)
 	snd_ctl_elem_value_set_interface(phono_input, SND_CTL_ELEM_IFACE_MIXER);
 	snd_ctl_elem_value_set_name(phono_input, "Phono Analog Input Switch");
 
+	snd_ctl_elem_value_set_interface(iec958_in_status, SND_CTL_ELEM_IFACE_MIXER); /* NPM: add feature to display "Delta IEC958 Input Status" */
+	snd_ctl_elem_value_set_name(iec958_in_status, "Delta IEC958 Input Status"); /* NPM: add feature to display "Delta IEC958 Input Status" */
 }
 
 void hardware_postinit(void)
@@ -810,4 +839,6 @@ void hardware_postinit(void)
 	spdif_output_update();
 	analog_input_select_update();
 	phono_input_update();
+	if (card_has_delta_iec958_input_status)
+	  iec958_input_status_timeout_callback(NULL); /* NPM */
 }
